; keysum_8bit.a51   shows sum of keypad and running sum; decimal adjust after initial binary display


; rev path 3/16
	$NOSYMBOLS	; keeps listing short
	$INCLUDE (C:\SiLabs\MCU\INC\c8051f410.inc) 

	STACKBOT EQU 80h	; put stack at start of scratch indirectly-addressable block (80h and up)


	DISPLAY   EQU   P1              ; low byte of LCD address
	KEYPAD		EQU   P2
	RUN_SUM		EQU R7

	DELAY_HIGHEST 	equ 04h
	DELAY_HI	equ		00h								
	DELAY_LO	equ   00h

	ORG 0h
	LJMP STARTUP

	ORG 080h
				
STARTUP: MOV SP, #STACKBOT-1

	acall USUAL_SETUP

          ; Initialize running sum
            clr   A
	     mov RUN_SUM, A									; clear running sum

Transfer: mov A, RUN_SUM	; recall running sum
	add A, KEYPAD		; form new sum
;	da A			; For decimal sum--try after watching binary addition
	mov RUN_SUM, A		; ...save it
	mov DISPLAY, A		; ...and show it
;	acall DELAY
	sjmp Transfer		; ...forever


;----SUBROUTINES ----

DELAY: PUSH ACC			; save registers that'll get messed up
			PUSH B
			PUSH 4						; ...and R4	
			MOV R4, #DELAY_HIGHEST		
THIRD_LOOP:	MOV A,#DELAY_HI				; get outer-loop delay value
INITINNER:	MOV B,#DELAY_LO			; initialize inner loop counter
INLOOP: 	DJNZ B, INLOOP		; count down inner loop, till inner hits zero
			DJNZ ACC,INITINNER	; ...then dec outer, and start inner again.
			DJNZ R4, THIRD_LOOP	; now the outermost loop
			POP 4			; restore saved registers
			POP B  				
			POP ACC
			RET			; Now back to main program.


USUAL_SETUP:            ; Disable the WDT.
            anl   PCA0MD, #NOT(040h)   ; Clear Watchdog Enable bit

					; Configure the Oscillator;
            orl   OSCICN, #04h         ; sysclk = 24.5 Mhz / 8, for lower power

            ; Enable the Port I/O Crossbar

            mov   XBR1, #40h           ; Enable Crossbar
						
	    ret
END
	
